<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div>

  <div
    class="h4 pb-2"
    id="layerElementTableTitle"
    [innerText]="messages.ELEMENT_TABLE_TITLE">
  </div>
  <table aria-labelledby="layerElementTableTitle" class="w-100 bg-white border shadow-sm">
    <thead>
      <tr>
        <th class="drag-handle-column p-1"></th>
        <th class="large-column p-1" [innerText]="messages.TYPE"></th>
        <th class="tiny-column p-1">
          {{ messages.PAGE }}
          <ng-template #pageTooltip>
            <div
              class="text-start px-2"
              [innerHtml]="messages.PAGE_TOOLTIP">
            </div>
          </ng-template>
          <fa-icon
            class="ps-1"
            [icon]="commonIcons.TOOLTIP_ICON"
            [ngbTooltip]="pageTooltip"
            [openDelay]="300">
          </fa-icon>
        </th>
        <th [innerText]="messages.X" class="tiny-column  p-1"></th>
        <th [innerText]="messages.Y" class="tiny-column  p-1"></th>
        <th [innerText]="messages.VALUE" class="metadata-column"></th>
        <th [innerText]="messages.FONT_SIZE" class="tiny-column  p-1"></th>
        <th [innerText]="messages.COLOR" class="tiny-column  p-1"></th>
        <th class="tiny-column p-1">
          {{ messages.SIGNATURE }}
          <fa-icon
            class="ps-1"
            [icon]="commonIcons.TOOLTIP_ICON"
            [ngbTooltip]="messages.SIGNATURE_TOOLTIP"
            openDelay="300">
          </fa-icon>
        </th>
        <th class="tiny-column p-1" [innerText]="commonMessages.ACTION"></th>
      </tr>
    </thead>
    <tbody (cdkDropListDropped)="onDrop($event)" cdkDropList>
      <tr *ngFor="let stamp of layer.stampList; let i = index"
          cdkDragLockAxis="y"
          cdkDragBoundary=".restricted-values-container-boundary"
          cdkDrag>
        <td class="drag-handle-column p-1">
          <fa-icon
            class="text-secondary p-2"
            [icon]="gripHorizontalIcon"
            cdkDragHandle>
          </fa-icon>
        </td>
        <td class="large-column p-1">
          <ng-select
            [items]="stampTypeEnum | keyvalue"
            bindValue="value"
            [disabled]="stamp.id != null"
            [(ngModel)]="stamp.type"
            [searchable]="false"
            [clearable]="false"
            [multiple]="false">

            <ng-template let-item="item" ng-option-tmp>
              <fa-icon
                [icon]="item.value | stampTypeIcon"
                [fixedWidth]="true">
              </fa-icon>
              <span class="ms-2" [innerText]="item.value | stampTypeName"></span>
            </ng-template>

            <ng-template let-item="item" ng-label-tmp>
              <span class="ng-value-label">
                <fa-icon
                  [icon]="item.value | stampTypeIcon"
                  [fixedWidth]="true">
                </fa-icon>
                <span class="ms-2" [innerText]="item.value | stampTypeName"></span>
              </span>
            </ng-template>
          </ng-select>
        </td>
        <td class="tiny-column p-1">
          <input
            type="number"
            class="form-control form-control-sm"
            min="-1"
            [(ngModel)]="stamp.page">
        </td>
        <td class="tiny-column p-1">
          <input
            type="number"
            class="form-control form-control-sm"
            min="0"
            [(ngModel)]="stamp.x">
        </td>
        <td class="tiny-column p-1">
          <input
            type="number"
            class="form-control form-control-sm"
            min="0"
            [(ngModel)]="stamp.y">
        </td>
        <td class="tiny-column p-1" *ngIf="stamp.type === stampTypeEnum.Signature"></td>
        <td class="value-column p-1" *ngIf="stamp.type === stampTypeEnum.Image">
          <input
            *ngIf="stamp.id == null"
            [disabled]="isUploadingFile"
            type="file"
            accept="image/jpeg,image/png"
            class="form-control-file"
            (change)="handleFileInput(stamp, $event)">
          <input
            *ngIf="stamp.id != null"
            [(ngModel)]="stamp.value"
            type="text"
            class="form-control"
            disabled>
        </td>
        <td class="value-column p-1" *ngIf="(stamp.type !== stampTypeEnum.Image) && (stamp.type !== stampTypeEnum.Signature)">
          <ng-select
            *ngIf="stamp.type === stampTypeEnum.Metadata"
            [notFoundText]="commonMessages.NOT_FOUND"
            [items]="metadataList"
            bindValue="id"
            [(ngModel)]="stamp.value"
            [searchable]="true"
            [clearable]="false"
            [multiple]="false">

            <ng-template let-item="item" ng-option-tmp>
              <span
                [innerText]="item | metadataName | namePipe"
                [ngbTooltip]="item | metadataName | namePipe">
              </span>
            </ng-template>

            <ng-template let-item="item" ng-label-tmp>
              <span
                [innerText]="item | metadataName | namePipe"
                [ngbTooltip]="item | metadataName | namePipe">
              </span>
            </ng-template>
          </ng-select>

          <input
            *ngIf="stamp.type !== stampTypeEnum.Metadata"
            type="text"
            class="form-control form-control-sm"
            [(ngModel)]="stamp.value">
        </td>
        <td class="tiny-column p-1" *ngIf="(stamp.type !== stampTypeEnum.Image) && (stamp.type !== stampTypeEnum.Signature)">
          <input
            type="number"
            class="form-control form-control-sm"
            min="0"
            [(ngModel)]="stamp.fontSize">
        </td>
        <td class="tiny-column p-1" *ngIf="(stamp.type !== stampTypeEnum.Image) && (stamp.type !== stampTypeEnum.Signature)">
          <ng-select
            [items]="stampTextColorEnum | keyvalue"
            bindValue="value"
            [(ngModel)]="stamp.textColor"
            [searchable]="false"
            [clearable]="false"
            [multiple]="false">

            <ng-template let-item="item" ng-option-tmp>
              <fa-icon
                [icon]="squareIcon"
                [fixedWidth]="true"
                style="{{ (item.value == stampTextColorEnum.Red) ? 'color:red' : 'color:black'}}">
              </fa-icon>
            </ng-template>

            <ng-template let-item="item" ng-label-tmp>
              <span class="ng-value-label">
                <fa-icon
                  [icon]="squareIcon"
                  [fixedWidth]="true"
                  style="{{ (item.value == stampTextColorEnum.Red) ? 'color:red' : 'color:black'}}">
                </fa-icon>
              </span>
            </ng-template>
          </ng-select>
        </td>
        <td class="tiny-column p-1">
          <input
            *ngIf="stamp.type === stampTypeEnum.Signature"
            type="number"
            class="form-control form-control-sm"
            min="-1"
            [(ngModel)]="stamp.signatureRank">

          <input
            *ngIf="stamp.type !== stampTypeEnum.Signature"
            type="checkbox"
            [(ngModel)]="stamp.afterSignature">
        </td>
        <td class="tiny-column p-1">
          <button
            type="button"
            class="btn btn-sm btn-outline-danger"
            [title]="commonMessages.DELETE"
            (click)="onDeleteButtonClicked(i)">
            <fa-icon
              [fixedWidth]="true"
              [icon]="commonIcons.DELETE_ICON">
            </fa-icon>
          </button>
        </td>
      </tr>
    </tbody>
  </table>

  <div class="flex-grow-1 d-flex flex-row-reverse">
    <button
      type="button"
      class="mt-3 btn btn-sm btn-primary"
      [disabled]="isUploadingFile"
      (click)="addNewStamp()">
      <fa-icon [icon]="commonIcons.ADD_ICON"></fa-icon>
      {{ messages.ADD_ELEMENT }}
    </button>
  </div>

</div>
